function [B]= FindandcheckB(A, rho, alphas, betas)

[alpha_0,alpha_1,alpha_2] = findal(alphas);

[n,m]=size(betas);
nr=m/2;
if round(nr)~=nr
    error('fatal (findandcheckB) right dimension of betas not divisible by 2')
end
beta_0=betas(:,[1:nr]);
beta_1=betas(:,[nr+1:2*nr]);

%Compute B matrix
%
d=rho'*beta_0'+beta_1';
[m,n]=size(d);
d=reshape(d,n*m,1);
q=kron(alpha_0,rho')+kron(alpha_1,eye(m))+kron(alpha_0*A,eye(m));

if rank(q) ~= m*n
    error('fatal (findandcheckB) q not of full rank')
end

delta=-q\d;
B=reshape(delta,m,n)';

F=(beta_0+alpha_0*B)*rho+(beta_1+alpha_1*B+alpha_0*A*B);

qq=max(max(abs(F)));

if qq > 8.9e-7
    error('fatal (findandcheckB) failed to solve for B')
end
