// by Ippei Fujiwara, July 25, 2006
// Simple RBC model with habit and investment adjustment cost
var c, lambda, h, k, q, i, r, sigma, b, chi, z, alpha, delta, eta, beta;
varexo e_sigma, e_b, e_chi, e_z, e_alpha, e_delta, e_eta, e_beta;

parameters sigma_bar, b_bar, chi_bar, z_bar, alpha_bar, delta_bar, spp, beta_bar, rho_sigma, rho_b, rho_chi, rho_z, rho_alpha, rho_delta, rho_eta, rho_beta;
sigma_bar=1;
b_bar=0.6;
//b_bar=0;
chi_bar=3;
z_bar=1;
alpha_bar=0.36;
delta_bar=0.025;
spp=9;
//spp=0;
beta_bar=.99;
rho_sigma=.9;
rho_b=.9;
rho_chi=.9;
rho_z=.9;
rho_alpha=.9;
rho_delta=.9;
rho_eta=.9;
rho_beta=.9;

model;
//(1)
(c-b_bar*exp(b)*c(-1))^(-exp(sigma)*sigma_bar)=lambda+exp(beta)*beta_bar*b_bar*exp(b(+1))*(c(+1)-b_bar*exp(b(+1))*c)^(-exp(sigma(+1))*sigma_bar);

//(2)
exp(chi)*chi_bar*h=lambda*(1-exp(alpha)*alpha_bar)*(exp(z)*h)^(-exp(alpha)*alpha_bar)*exp(z)*(k(-1))^(exp(alpha)*alpha_bar);

//(3)
1=q*(1-spp*(.5*(i/i(-1))^2*exp(eta)-i/i(-1)*exp(eta)+.5)-spp*exp(eta)*(i/i(-1)-1)*i/i(-1))+exp(beta)*beta_bar*lambda(+1)/lambda*q(+1)*spp*exp(eta(+1))*(i(+1)/i-1)*(i(+1)/i)^2;

//(4)
q=exp(beta)*beta_bar*lambda(+1)/lambda*(exp(alpha(+1))*alpha_bar*(exp(z(+1))*h(+1))^(1-exp(alpha(+1))*alpha_bar)*k^(exp(alpha(+1))*alpha_bar-1)+q(+1)*(1-exp(delta(+1))*delta_bar));

//(5)
c+i=(exp(z)*h)^(1-exp(alpha)*alpha_bar)*k(-1)^(exp(alpha)*alpha_bar);

//(6)
k=(1-exp(delta)*delta_bar)*k(-1)+(1-spp*(.5*exp(eta)*(i/i(-1))^2-exp(eta)*i/i(-1)+.5))*i;

//(7)
1/r=exp(beta)*beta_bar*lambda(+1)/lambda;

//shocks
//(8)
sigma=rho_sigma*sigma(-1)+e_sigma;

//(9)
b=rho_b*b(-1)+e_b;

//(10)
chi=rho_chi*chi(-1)+e_chi;

//(11)
z=rho_z*z(-1)+e_z;

//(12)
alpha=rho_alpha*alpha(-1)+e_alpha;

//(13)
delta=rho_delta*delta(-1)+e_delta;

//(14)
eta=rho_eta*eta(-1)+e_eta;

//(15)
beta=rho_beta*beta(-1)+e_beta;
end;

initval;
c=1;
lambda=1;
h=1;
k=1;
q=1;
i=1;
r=1;
sigma=0;
b=0;
chi=0;
z=0;
alpha=0;
delta=0;
eta=0;
beta=0;
e_sigma=0;
e_b=0;
e_chi=0;
e_z=0;
e_alpha=0;
e_delta=0;
e_eta=0;
e_beta=0;
end;

shocks;
var e_sigma; stderr 0.01;
var e_b; stderr 0.01;
var e_chi; stderr 0.01;
var e_z; stderr 0.01;
var e_alpha; stderr 0.01;
var e_delta; stderr 0.01;
var e_eta; stderr 0.01;
var e_beta; stderr 0.01;
end;

steady;
check;

stoch_simul(linear);
